<?php

class KuaimaiLib
{
    //分配的APPkey
    private $appkey = 'xxxxx';
    //分配的appSecret
    private $appscret = 'xxxxx';
    //分配的accessToken
    private $token = 'xxxxx';
    //服务器地址
    private $serviceUrl = 'https://pubgwerp.superboss.cc/router';

    /*
     * 封装常用的参数
     * $method 接口名
     * $sign_method 加密方式 hmac，md5，hmac-sha256
     */
    public function getCommonParams($method,$sign_method)
    {
        $params = array();
        $params['method'] = $method;
        $params['appKey'] = $this->appkey;
        $params['timestamp'] = date('Y-m-d H:i:s');
        $params['format'] = 'json';
        $params['session'] = $this->token;
        $params['version'] = '1.0';
        if (empty($sign_method)){
            $params['sign_method'] = 'md5';
        }else{
            $params['sign_method'] = $sign_method;
        }
        return $params;
    }

    /*
     * 加密
     * $params 要传递的参数是一个array(键-值对)
     * $appscret 由快麦开放平台提供的appscret
     * $token 由快麦开放平台提供的accessToken
     */
    public function signature($params)
    {
        $temArr = $params;
        // 按照键名对关联数组进行升序排序
        ksort($temArr);
        // 把所有参数名和参数值串在一起
        foreach ($temArr as $key => $value) {
            if ($key && strlen($value) > 0) {
                $paramsStr = $paramsStr . $key . $value;
            }
        }

        if('md5' == $params['sign_method']){
            $paramsStr = $this->appscret . $paramsStr . $this->appscret;
        }
        echo '<br/>加密内容：<br/>' . htmlentities($paramsStr) . '<br/><br/>';

        //加密
        if('md5' == $params['sign_method']) {
            return strtoupper(md5($paramsStr));
        } elseif ('hmac' == $params['sign_method']) {
            return strtoupper(hash_hmac('md5',$paramsStr,$this->appscret));
        }elseif ('hmac-sha256' == $params['sign_method']) {
            return strtoupper(hash_hmac('sha256',$paramsStr,$this->appscret));
        }
    }

    /*
     * 调用快麦开放平台的服务
     * $url 由快麦开放平台提供服务器地址(可以在https://open-doc.kuaimai.com查看：API调用方法详解)
     * $params 要传递的参数是一个array(键-值对)
     * $appscret 由快麦开放平台提供的appscret
     * $token 由快麦开放平台提供的token
     */
    public function requstPost($params)
    {
        $params['sign'] = $this->signature($params);
        $data = http_build_query($params);
        $opts = array(
            'http' => array(
                'method' => 'POST',
                'header' => 'Content-type: application/x-www-form-urlencoded',
                'content' => $data
            )
        );
        echo '<br/>serviceUrl：' .$this->serviceUrl;
        echo '<br/><br/>发送报文：<br/>' .htmlentities($this->getStr($params)) . '<br/><br/>';
        echo '<br/>实际发送参数：<br/>' . $data . '<br/><br/>';
        $context = stream_context_create($opts);
        $html = file_get_contents($this->serviceUrl, false, $context);
        return $html;
    }
    private function getStr($params){
        $result='';
        foreach ($params as $key => $value) {
             $result = $result . $key .'='. $value.'&';
        }
        return substr($result, 0,strlen($result)-1);
    }
}
?>